// C Source File
// Created 25/05/01; 10:15:01

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
short _ti92plus;              // Produce .9XZ File
unsigned short route[12];

#include "vehicules.h"  
#include "draw.h"
#include "menus.h"
#include "fonctions.h"


// Main Function
void _main(void)
{
int i,x,car;
int score=100;
short bufdelay,bufrepet;
char *buffer = "          ";
unsigned char *lcd;
unsigned char *lcd1;
unsigned char *lcd2;
unsigned char *lcd3;
unsigned short key;
unsigned char road_layer[3840];

bufdelay = OSInitKeyInitDelay(80);          // Acclre la vitesse de rptition ...
bufrepet = OSInitBetweenKeyDelay(20);        // ... du clavier
for(i=0;i<3840;i++)
	road_layer[i]=0;
ClearScreen();
	GrayOn();
	pl0 = GetPlane(0);
	pl1 = GetPlane(1);
welcome:
	window(" ");
	drawline(pl0,10,64,230,64,A_REPLACE);
	drawline(pl1,10,64,230,64,A_REPLACE);
	drawline(pl0,10,62,230,62,A_REPLACE);
	drawline(pl0,10,66,230,66,A_REPLACE);
	drawline(pl1,10,63,230,63,A_REPLACE);
	drawline(pl1,10,65,230,65,A_REPLACE);
	
	blackDrawStr(68,28,"JackyCar v0.1b",A_NORMAL);
	blackDrawStr(40,40,"Par la JanjanII TEAM",A_NORMAL);
	blackDrawStr(48,80,"pressez une touche",A_NORMAL);
	blackDrawStr(48,94,"[ESC] pour quitter",A_NORMAL);
	if(ngetchx()==KEY_ESC)
		goto end;
InitVehicules();
choicecar:	
	window("choisissez un vehicule");	
		
	spr24(59,51,33,vehicules[0].light,vehicules[0].mask,pl0);
	spr24(59,51,33,vehicules[0].dark,vehicules[0].mask,pl1);
	spr24(91,51,33,vehicules[1].light,vehicules[1].mask,pl0);
	spr24(91,51,33,vehicules[1].dark,vehicules[1].mask,pl1);
	spr24(122,51,33,vehicules[2].light,vehicules[2].mask,pl0);
	spr24(122,51,33,vehicules[2].dark,vehicules[2].mask,pl1);
	spr24(154,51,33,vehicules[3].light,vehicules[3].mask,pl0);
	spr24(154,51,33,vehicules[3].dark,vehicules[3].mask,pl1);
	
	
	rectangle(55,47,85,86,A_XOR,pl1);
	rectangle(56,48,84,85,A_XOR,pl0);
	i=0;
	blackDrawStr(72,100,vehicules[i].nom,A_REPLACE);
	while((key = ngetchx())!=KEY_ENTER)
	{
		switch(key)
		{
			case 340        :if(i<3){
											rectangle((55+(i*32)),47,(85+(i*32)),86,A_XOR,pl1);
											rectangle((56+(i*32)),48,(84+(i*32)),85,A_XOR,pl0);
											i++;
											rectangle((55+(i*32)),47,(85+(i*32)),86,A_XOR,pl1);
											rectangle((56+(i*32)),48,(84+(i*32)),85,A_XOR,pl0);
											}
											else{
											rectangle((55+(i*32)),47,(85+(i*32)),86,A_XOR,pl1);
											rectangle((56+(i*32)),48,(84+(i*32)),85,A_XOR,pl0);
											rectangle(55,47,85,86,A_XOR,pl1);
											rectangle(56,48,84,85,A_XOR,pl0);
											i=0;
											}
											break;
				case 337      :if(i>0){
											rectangle((55+(i*32)),47,(85+(i*32)),86,A_XOR,pl1);
											rectangle((56+(i*32)),48,(84+(i*32)),85,A_XOR,pl0);
											i--;
											rectangle((55+(i*32)),47,(85+(i*32)),86,A_XOR,pl1);
											rectangle((56+(i*32)),48,(84+(i*32)),85,A_XOR,pl0);
											}
											else{
											rectangle((55+(i*32)),47,(85+(i*32)),86,A_XOR,pl1);
											rectangle((56+(i*32)),48,(84+(i*32)),85,A_XOR,pl0);
											i=3;
											rectangle((55+(i*32)),47,(85+(i*32)),86,A_XOR,pl1);
											rectangle((56+(i*32)),48,(84+(i*32)),85,A_XOR,pl0);
											}
											break;
				case KEY_F1:Help();break;
				case KEY_ESC:
				goto welcome;
		}
		
		blackDrawStr(72,100,vehicules[i].nom,A_REPLACE);

	}
	window("confirmation");	
		spr24(108,51,33,(vehicules[i].light),(vehicules[i].mask),pl0);
		spr24(108,51,33,(vehicules[i].dark ),(vehicules[i].mask),pl1);
		SetPlane(1);DrawStr(72,100,vehicules[i].nom,A_REPLACE);
		SetPlane(0);DrawStr(72,100,vehicules[i].nom,A_REPLACE);
	if(ngetchx()==KEY_ESC)
		goto choicecar;
car=i;		

//FIN DES MENUS
OSInitKeyInitDelay(20);          // Acclre la vitesse de rptition ...
OSInitBetweenKeyDelay(10);        // ... du clavier
lcd = road_layer;
lcd +=210;
lcd2 = GetPlane(1);
lcd2 +=210;
lcd1 = road_layer;
lcd1 +=(210+(((vehicules[car].j)-1)*30));
lcd3 = GetPlane(1);
lcd3 +=2550;

	
SetPlane(0);
clrscr();
SetPlane(1);
clrscr();
FontSetSys(F_4x6);
x=102;
route[1]=80;
while(1)
{
if(!GETPIX(road_layer,(x+12),101))
	score++;
else{
	score-=30;
	}
if(score<0)
	goto end;
sprintf(buffer,"%d     ",score);
DrawStr(0,0,buffer,A_REPLACE);
	for(i=1;i<(vehicules[car].j);i++)
		evoluate(vehicules[car].ev);
		
	memmove(lcd1,lcd,(3570-(30*(vehicules[car].j))));
	for(i=1;i<(vehicules[car].j);i++)
	{
		drawline(road_layer,route[i],(i+6),(route[i]+80),(i+6),A_REVERSE);
  		drawline(road_layer,1,(i+6),route[i],(i+6),A_REPLACE);
		drawline(road_layer,(route[i]+80),(i+6),240,(i+6),A_REPLACE);
  	
	}
	if((_rowread(~((short)(1<<0))) & (1<<4))&&x>1)//GAUCHE
		{x-=(vehicules[car].dep);
		DrawClear(33,(x+24),(vehicules[car].dep));}
	else
	if((_rowread(~((short)(1<<0))) & (1<<6))&&x<205)//DROITE
		{DrawClear(33,(x),(vehicules[car].dep));
		x+=(vehicules[car].dep);}
	else
	if(_rowread(~((short)(1<<6))) & (1<<4))//F1
		{
			GKeyFlush();
			FontSetSys(F_8x10);
			blackDrawStr(100,55,"PAUSE",A_XOR);
			FontSetSys(F_4x6);
			blackDrawStr(88,67,"(press [ESC] to exit)",A_XOR);
			if(ngetchx()==KEY_ESC)
				goto end;
			FontSetSys(F_8x10);
			blackDrawStr(100,55,"PAUSE",A_XOR);
			FontSetSys(F_4x6);
			blackDrawStr(88,67,"(press [ESC] to exit)",A_XOR);	
		}
	memcpy(lcd2,lcd,3570);
	spr24(x,85,33,(vehicules[car].light),(vehicules[car].mask),GetPlane(0));
	spr24(x,85,33,(vehicules[car].dark ),(vehicules[car].mask),GetPlane(1));
}
end:
OSInitKeyInitDelay(bufdelay);
OSInitBetweenKeyDelay(bufrepet);
	GrayOff();
}
